Index: graphics/wxWidgets-3.0/Portfile
===================================================================
--- graphics/wxWidgets-3.0/Portfile	(revision 112047)
+++ graphics/wxWidgets-3.0/Portfile	(working copy)
@@ -19,7 +19,7 @@
     wxWidgets.use   wxWidgets-3.0
 } elseif {$subport == "wxPython-3.0"} {
     wxWidgets.use   wxPython-3.0
-    version         2.9.4
+    revision        0
 } elseif {$subport == "wxgtk-3.0"} {
     # with satisfactory Cocoa support there is no real need for GTK-based wxWidgets any more
     # wxgtk-3.0 is here mainly for testing purposes
@@ -52,7 +52,8 @@
 distfiles           ${distname}-${version}${extract.suffix}
 dist_subdir         ${distname}/${version}
 
-checksums           rmd160  f5c91099b2cf3e39eadbcf99df0dd9a97017d47f \
+checksums           ${distname}-${version}${extract.suffix} \
+                    rmd160  f5c91099b2cf3e39eadbcf99df0dd9a97017d47f \
                     sha256  b74ba96ca537cc5d049d21ec9ab5eb2670406a4aa9f1ea4845ea84a9955a6e02
 
 depends_lib         port:jpeg \
@@ -98,25 +99,17 @@
                     --with-macosx-version-min=no
 
 if {$subport == "wxPython-3.0"} {
-    set wxpythonsubset      wxPython-2.9.4.0-MacPorts-subset
+    set wxpythonsubset      wxPython-2.9.5.0-MacPorts-subset
     distfiles-append        ${wxpythonsubset}${extract.suffix}:trac
 
-    # patch-src-osx-cocoa-window.mm.diff: http://trac.wxwidgets.org/changeset/72195 (only needed for 2.9.4)
-    # patch-include-wx-math.h.diff:       http://trac.wxwidgets.org/changeset/74456 (only needed for 2.9.4)
-    patchfiles-append       patch-src-osx-cocoa-window.mm.diff \
-                            patch-include-wx-math.h.diff
-
     description             wxWidgets ${branch} for the wxPython distribution
     long_description        The port installs wxWidgets ${branch} for wxPython \
                             to guarantee compatibility even when the upstream versions \
                             of wxWidgets and wxPython differ.
 
-    checksums               ${distname}-${version}${extract.suffix} \
-                            rmd160  62301f8ce39a8aa96e65318f9d1e947c9dc09c50 \
-                            sha256  6c530c35f40c3b1a5f9a4577c3ee8a9982e745081f23e3fbb9951d6d17514d12 \
-                            ${wxpythonsubset}${extract.suffix} \
-                            rmd160  7831cee8185c521d8b565b56555b3005dee1d53d \
-                            sha256  971b644768d4010b38acf7232deb8cf3c91921ca8b09dec82c1616b93c751f4c
+    checksums-append        ${wxpythonsubset}${extract.suffix} \
+                            rmd160  936858d5856adde043d107164b1b53d3209eb76d \
+                            sha256  c892f257b151726a70886c7cffda51554b48b8e9cc7cfcc962d6988c5fe81856
 
     post-destroot {
         # copy a subset of wxPython to wxWidgets to prevent a conflict
@@ -127,7 +120,6 @@
     livecheck.type          none
 } elseif {$subport == "wxgtk-3.0"} {
     # both patches could be added to wxWidgets-3.0, but they are not needed for Cocoa
-    # and might need changes for wxWidgets 2.9.4
     #
     # patch-sdl.diff: the patch allows using --wxth-sdl
     # patch-upstream-psn.diff: http://trac.wxwidgets.org/changeset/74703
Index: graphics/wxWidgets-3.0/files/patch-configure.diff
===================================================================
--- graphics/wxWidgets-3.0/files/patch-configure.diff	(revision 112047)
+++ graphics/wxWidgets-3.0/files/patch-configure.diff	(working copy)
@@ -1,5 +1,5 @@
 The first part is for GTK and makes sure that the port finds the right OpenGL library
-The second part makes sure that install_name_tool doesn't break library names and links (http://trac.wxwidgets.org/ticket/15452)
+The second part is an upstream patch (see http://trac.wxwidgets.org/ticket/15452)
 --- configure.orig
 +++ configure
 @@ -22038,48 +22038,7 @@ ac_compiler_gnu=$ac_cv_c_compiler_gnu
@@ -52,28 +52,28 @@
  
  { $as_echo "$as_me:${as_lineno-$LINENO}: checking for libraries directories" >&5
  $as_echo_n "checking for libraries directories... " >&6; }
-@@ -29402,24 +29361,6 @@ rm -f core conftest.err conftest.$ac_objext \
-       ;;
- 
-       *-*-darwin* )
--        install_name_tool=`which ${HOST_PREFIX}install_name_tool`
--        if test "$install_name_tool" -a -x "$install_name_tool"; then
--            DYLIB_RPATH_POSTLINK="${HOST_PREFIX}install_name_tool -id \$@ \$@"
--            cat <<EOF >change-install-names
--#!/bin/sh
+@@ -29407,16 +29366,18 @@ rm -f core conftest.err conftest.$ac_objext \
+             DYLIB_RPATH_POSTLINK="${HOST_PREFIX}install_name_tool -id \$@ \$@"
+             cat <<EOF >change-install-names
+ #!/bin/sh
 -libnames=\`cd \${2} ; ls -1 | grep '\.[0-9][0-9]*\.dylib\$'\`
--for i in \${libnames} ; do
++libnames=\`cd \${1} ; ls -1 | grep '\.[0-9][0-9]*\.dylib\$'\`
++changes=''
++for dep in \${libnames} ; do
++    changes="\${changes} -change \${4}/\${dep} \${3}/\${dep}"
++done
+ for i in \${libnames} ; do
 -    ${HOST_PREFIX}install_name_tool -id \${3}/\${i} \${1}/\${i}
 -    for dep in \${libnames} ; do
 -        ${HOST_PREFIX}install_name_tool -change \${2}/\${dep} \${3}/\${dep} \${1}/\${i}
 -    done
--done
--EOF
--            chmod +x change-install-names
++    ${HOST_PREFIX}install_name_tool \${changes} -id \${3}/\${i} \${1}/\${i}
+ done
++${HOST_PREFIX}install_name_tool \${changes} \${2}/wxrc-${WX_RELEASE}
+ EOF
+             chmod +x change-install-names
 -            DYLIB_RPATH_INSTALL="\$(wx_top_builddir)/change-install-names \${DESTDIR}\${libdir} \$(wx_top_builddir)/lib \${libdir}"
--        fi
--
--                                        HEADER_PAD_OPTION="-headerpad_max_install_names"
-       ;;
++            DYLIB_RPATH_INSTALL="\$(wx_top_builddir)/change-install-names \${DESTDIR}\${libdir} \${DESTDIR}\${bindir} \${libdir} \$(wx_top_builddir)/lib"
+         fi
  
-       *-*-cygwin* | *-*-mingw32* )
+                                         HEADER_PAD_OPTION="-headerpad_max_install_names"
Index: python/py-wxpython-3.0/Portfile
===================================================================
--- python/py-wxpython-3.0/Portfile	(revision 112047)
+++ python/py-wxpython-3.0/Portfile	(working copy)
@@ -6,7 +6,8 @@
 PortGroup           wxWidgets   1.0
 
 name                py-wxpython-3.0
-version             2.9.4.0
+version             2.9.5.0
+set wx_version      [join [lrange [split ${version} .] 0 2] .]
 set branch          [join [lrange [split ${version} .] 0 1] .]
 categories-append   graphics devel
 license             wxwidgets-3.1
@@ -27,15 +28,15 @@
 distname            wxPython
 use_bzip2           yes
 
-checksums           rmd160  35e823d9161dc99083f3025383567000680e012f \
-                    sha256  78c35c19e85a17cb9c730b86b49d6a479198d76d19e0b13e86db0b55707004be
+checksums           rmd160  4d54edc5437fbe14e552bfc6feeeb4fb74d10cd0 \
+                    sha256  1a5b7e771eff467538d0834136188e8a7506a4fe6e85d0a46c40158cdbd4c48c
 
 python.versions     27
 python.default_version 27
 
 distfiles           ${distname}-src-${version}${extract.suffix}
-dist_subdir         ${distname}/${version}
 worksrcdir          ${distname}-src-${version}/wxPython
+dist_subdir         wxWidgets/${wx_version}
 
 # extract just the docs and wxPython subdir
 extract.post_args   "| tar -xf - ${worksrcdir} ${distname}-src-${version}/docs"
@@ -42,6 +43,9 @@
 
 if {$subport != $name} {
     conflicts           py${python.version}-wxpython-2.8
+    # As long as wxPython and wxWidgets are at the same version,
+    # this port could also depend on wxWidgets-3.0.
+    # A separate port is there just because wxPython usually lags behind.
     wxWidgets.use       wxPython-3.0
     depends_lib-append  port:${wxWidgets.port}
 
@@ -52,7 +56,11 @@
     destroot.cmd    ${python.bin} setup.py WX_CONFIG="${wxWidgets.wxconfig}"
 
     post-destroot {
-        # this has already been added by wxWidgets
+        # When a new release of wxPython comes out, the contents of
+        # ${destroot}${wxWidgets.prefix}/Versions/wxPython/${branch}/include/wx-${branch}/wx/wxPython
+        # should be stored separately into wxPython-${version}-MacPorts-subset.tar.bz2
+        # to be extracted/installed by wxPython-3.0 rather than this port.
+        # This allows parallel installation of several versions of py**-wxpython-3.0.
         delete      ${destroot}${wxWidgets.prefix}
     }
 