Index: Portfile
===================================================================
--- Portfile	(revision 112435)
+++ Portfile	(working copy)
@@ -6,8 +6,7 @@
 PortGroup           compiler_blacklist_versions 1.0
 
 name                erlang
-version             R16B01
-revision            1
+version             R16B02
 categories          lang erlang
 maintainers         bfulgham
 platforms           darwin
@@ -31,8 +30,7 @@
                     Ericsson ATM switch.
 
 homepage            http://www.erlang.org/
-master_sites        http://www.erlang.org/download/ \
-                    http://www.erlang.org/download/patches/:patches
+master_sites        http://www.erlang.org/download/
 
 # Parallel build doesn't work as per R13B01
 use_parallel_build  no
@@ -44,14 +42,14 @@
                     otp_doc_html_${version}${extract.suffix}
 
 checksums           otp_src_${version}.tar.gz \
-                    rmd160  0e3eccb9ec2797dab0a43e94434e148e971ded7c \
-                    sha256  da388bc07b8ebdd008f5bb6c3d2c280e358bd188b5aac3ea01e3a7436315abc0 \
+                    rmd160  d10ad82b3bddf16d1cf52babd56965537b64faeb \
+                    sha256  6ab8ad1df8185345554a4b80e10fd8be06c4f2b71b69dcfb8528352787b32f85 \
                     otp_doc_man_${version}.tar.gz \
-                    rmd160  80b641464e1bc458626aa2f15693588375a99c16 \
-                    sha256  71972049fbac73457fb6868be18068edce9f2c9fc2aeeab15f019d4217b6a8c2 \
+                    rmd160  5f0f36831d996882e55b168acd209892156e6bb8 \
+                    sha256  b79ceb0383415088b5f040f2f3705632b425cb3f29c3955ef2219556abec5789 \
                     otp_doc_html_${version}.tar.gz \
-                    rmd160  46fa69b8ec46c1c5a77d0ead33aa7fcd5a9b36fd \
-                    sha256  fa8fc507b3f799e8ff4d2ab800f054f3f99b39212e348504024403a6951bd036
+                    rmd160  20315bfa218469d045f0f69a52305a89e138f6e6 \
+                    sha256  2d54119b30c4d905b6b1298865309c3392fefb1580ad69725e997644bed04b7f
 
 pre-patch         { file rename ${workpath}/otp_src_${version} ${workpath}/${name}-${version} }
 
@@ -59,7 +57,6 @@
 patchfiles          patch-toolbar.erl.diff \
                     patch-erts_emulator_Makefile.in.diff \
                     patch-erts_configure.diff \
-                    patch-disable_wx.diff
 
 configure.args      --prefix=${prefix}       \
                     --enable-kernel-poll     \
@@ -68,7 +65,8 @@
                     --enable-smp-support     \
                     --enable-hipe            \
                     --without-ssl            \
-                    --without-odbc
+                    --without-odbc           \
+                    --without-wx
 
 depends_build       port:gawk port:perl5
 # ${prefix}/lib/erlang/erts-5.8.4/bin/beam.smp links with ncurses
@@ -82,9 +80,9 @@
     system "tar -C ${destroot}${prefix}/lib/erlang -zxvf ${distpath}/otp_doc_html_${version}${extract.suffix}"
     system "tar -C ${destroot}${prefix}/lib/erlang -zxvf ${distpath}/otp_doc_man_${version}${extract.suffix}"
  
-    set erts_dir            erts-5.10.2
-    set erl_interface_dir   erl_interface-3.7.13
-    set wx_dir              wx-1.0
+    set erts_dir            erts-5.10.3
+    set erl_interface_dir   erl_interface-3.7.14
+    set wx_dir              wx-1.1
 
     reinplace s|${destroot}|| ${destroot}${prefix}/lib/erlang/bin/erl
     reinplace s|${destroot}|| ${destroot}${prefix}/lib/erlang/bin/start
@@ -121,12 +119,12 @@
 
 variant wxwidgets description {Build wxWidgets support} {
     wxWidgets.use               wxWidgets-3.0
-    patchfiles-delete           patch-disable_wx.diff
     patchfiles-append           patch-lib_wx_configure.in.diff \
                                 patch-lib_wx_configure.diff
     depends_lib-append          port:${wxWidgets.port}
     depends_run-append          port:tk
     configure.args-append       --with-wxdir=${wxWidgets.wxdir}
+    configure.args-delete       --without-wx
 }
 
 variant ssl description {Build SSL support} {
@@ -138,6 +136,7 @@
 
 variant nohipe description {Disable HiPE (native-code bytecode compiler)}   {
     configure.args-delete       --enable-hipe
+    configure.args-append       --disable-hipe
 }
 
 variant odbc description {Build ODBC support} {
Index: files/patch-disable_wx.diff
===================================================================
--- files/patch-disable_wx.diff	(revision 112435)
+++ files/patch-disable_wx.diff	(working copy)
@@ -1,31 +0,0 @@
---- lib/configure.orig
-+++ lib/configure
-@@ -277,7 +277,6 @@ ac_subdirs_all="$ac_subdirs_all erl_interface/."
- ac_subdirs_all="$ac_subdirs_all gs/."
- ac_subdirs_all="$ac_subdirs_all megaco/."
- ac_subdirs_all="$ac_subdirs_all odbc/."
--ac_subdirs_all="$ac_subdirs_all wx/."
- ac_subst_vars='SHELL PATH_SEPARATOR PACKAGE_NAME PACKAGE_TARNAME PACKAGE_VERSION PACKAGE_STRING PACKAGE_BUGREPORT exec_prefix prefix program_transform_name bindir sbindir libexecdir datadir sysconfdir sharedstatedir localstatedir libdir includedir oldincludedir infodir mandir build_alias host_alias target_alias DEFS ECHO_C ECHO_N ECHO_T LIBS subdirs LIBOBJS LTLIBOBJS'
- ac_subst_files=''
- 
-@@ -1285,9 +1284,6 @@ subdirs="$subdirs megaco/."
-     test ! -f odbc/configure ||
- 
- subdirs="$subdirs odbc/."
--    test ! -f wx/configure ||
--
--subdirs="$subdirs wx/."
- 
- 
- fi
---- lib/Makefile.orig
-+++ lib/Makefile
-@@ -25,7 +25,7 @@ OTHER_SUB_DIRECTORIES = tools test_server common_test runtime_tools \
- ifdef BUILD_ALL
-   OTHER_SUB_DIRECTORIES += \
-           snmp otp_mibs appmon erl_interface asn1 jinterface \
--          wx debugger reltool gs \
-+          debugger reltool gs \
-           ic mnesia crypto orber os_mon parsetools syntax_tools \
-           pman public_key ssl toolbar tv observer odbc diameter \
-           cosTransactions cosEvent cosTime cosNotification \