Index: Portfile
===================================================================
--- Portfile	(revision 112376)
+++ Portfile	(working copy)
@@ -10,20 +10,19 @@
 
 name                        cairo-devel
 conflicts                   cairo
-set my_name                 cairo
-version                     1.12.16
-revision                    1
+set git_name                cairo
+set git_commit              6f05ecf488314e4b0c6c6b0110963c449bebe7d7
+version                     1.13.1
+revision                    20131011
 categories                  graphics
 maintainers                 ryandesign
 license                     {LGPL-2.1 MPL-1.1}
 homepage                    http://cairographics.org/
-master_sites                ${homepage}snapshots/
-master_sites                ${homepage}releases/
+master_sites                http://cgit.freedesktop.org/cairo/snapshot/
 platforms                   darwin macosx
 use_parallel_build          yes
-dist_subdir                 ${my_name}
-distname                    ${my_name}-${version}
-use_xz                      yes
+dist_subdir                 ${git_name}
+distname                    ${git_name}-${git_commit}
 
 description                 a vector graphics library with cross-device output support
 
@@ -32,10 +31,13 @@
                             advantage of display hardware acceleration when \
                             available (e.g. through the X Render Extension).
 
-checksums                   rmd160  379283c2f5c9690bdfd69c629b8efd59be7a8670 \
-                            sha256  2505959eb3f1de3e1841023b61585bfd35684b9733c7b6a3643f4f4cbde6d846
+checksums                   rmd160  3c42d8c1917983deffe9035c9528eb96a480d6bd \
+                            sha256  49769ff9bf2afc7fe7fa929af35a664a6dcf409a253ebed407f3474d6c767296
 
-depends_build               port:pkgconfig
+depends_build               port:pkgconfig \
+                            port:autoconf \
+                            port:automake \
+                            port:libtool
 
 depends_lib                 path:lib/pkgconfig/pixman-1.pc:libpixman \
                             path:lib/pkgconfig/glib-2.0.pc:glib2 \
@@ -48,7 +50,7 @@
 minimum_xcodeversions       {8 2.4.1}
 
 # Prevent cairo from using librsvg, libspectre, poppler.
-patchfiles-append           patch-configure.diff
+patchfiles-append           patch-configure.ac.diff
 
 # https://trac.macports.org/ticket/34137
 compiler.blacklist-append   {clang < 318.0.61}
@@ -59,7 +61,7 @@
 }
 
 pre-configure {
-    set pixman_minimum_version 0.20.2
+    set pixman_minimum_version 0.30.0
     set pixman_installed_version [exec ${prefix}/bin/pkg-config pixman-1 --modversion]
     if {[vercmp ${pixman_installed_version} ${pixman_minimum_version}] < 0} {
         ui_error "${name} ${version} requires libpixman ${pixman_minimum_version} or later but you have libpixman ${pixman_installed_version}."
@@ -67,6 +69,8 @@
     }
 }
 
+configure.cmd               ./autogen.sh
+
 configure.args              --disable-gl \
                             --disable-quartz \
                             --disable-quartz-font \
@@ -132,6 +136,4 @@
 test.run                    yes
 test.target                 check
 
-livecheck.type              regex
-livecheck.url               ${homepage}news/
-livecheck.regex             ${my_name}-(\[0-9\]+\\.\[0-9\]*\[13579\]\\.\[0-9\]+)
+livecheck.type              none
Index: files/patch-configure.ac.diff
===================================================================
--- files/patch-configure.ac.diff	(revision 0)
+++ files/patch-configure.ac.diff	(working copy)
@@ -0,0 +1,29 @@
+--- configure.ac.orig	2013-10-10 13:41:41.000000000 -0700
++++ configure.ac	2013-10-10 13:43:24.000000000 -0700
+@@ -558,7 +558,7 @@
+ 
+ dnl ===========================================================================
+ 
+-SPECTRE_VERSION_REQUIRED=0.2.0
++SPECTRE_VERSION_REQUIRED=99999
+ test_ps=no
+ any2ppm_ps=no
+ if test "x$use_ps" = "xyes"; then
+@@ -596,7 +596,7 @@
+ dnl ===========================================================================
+ 
+ # poppler-0.17.4 fixes text-pattern and text-transform
+-POPPLER_VERSION_REQUIRED=0.17.4
++POPPLER_VERSION_REQUIRED=99999
+ test_pdf=no
+ any2ppm_pdf=no
+ if test "x$use_pdf" = "xyes"; then
+@@ -627,7 +627,7 @@
+   fi
+ ])
+ 
+-LIBRSVG_VERSION_REQUIRED=2.15.0
++LIBRSVG_VERSION_REQUIRED=99999
+ test_svg=no
+ any2ppm_svg=no
+ if test "x$use_svg" = "xyes"; then
Index: files/patch-configure.diff
===================================================================
--- files/patch-configure.diff	(revision 112376)
+++ files/patch-configure.diff	(working copy)
@@ -1,29 +0,0 @@
---- configure.orig	2013-08-26 12:00:41.000000000 -0500
-+++ configure	2013-10-02 10:25:37.000000000 -0500
-@@ -30488,7 +30488,7 @@
- 
- 
- 
--SPECTRE_VERSION_REQUIRED=0.2.0
-+SPECTRE_VERSION_REQUIRED=99999
- test_ps=no
- any2ppm_ps=no
- if test "x$use_ps" = "xyes"; then
-@@ -30885,7 +30885,7 @@
- 
- 
- # poppler-0.17.4 fixes text-pattern and text-transform
--POPPLER_VERSION_REQUIRED=0.17.4
-+POPPLER_VERSION_REQUIRED=99999
- test_pdf=no
- any2ppm_pdf=no
- if test "x$use_pdf" = "xyes"; then
-@@ -31255,7 +31255,7 @@
- 
- 
- 
--LIBRSVG_VERSION_REQUIRED=2.15.0
-+LIBRSVG_VERSION_REQUIRED=99999
- test_svg=no
- any2ppm_svg=no
- if test "x$use_svg" = "xyes"; then