--- Portfile.orig	2013-11-05 14:58:23.000000000 +0100
+++ Portfile	2013-11-05 15:56:51.000000000 +0100
@@ -1,37 +1,37 @@
 # -*- coding: utf-8; mode: tcl; tab-width: 4; indent-tabs-mode: nil; c-basic-offset: 4 -*- vim:fenc=utf-8:ft=tcl:et:sw=4:ts=4:sts=4
 # $Id: Portfile 92837 2012-05-09 00:51:48Z ryandesign@macports.org $
 
-PortSystem                  1.0
+PortSystem          1.0
 
-name                        gmt5
-version                     5.0.0b
-revision                    2
-categories                  science
-platforms                   darwin
-maintainers                 eprofs.de:florian takeshi
-license                     LGPL-3
-description                 the generic mapping tools
+name                gmt5
+version             5.0.0b
+revision            2
+categories          science
+platforms           darwin
+maintainers         eprofs.de:florian takeshi
+license             LGPL-3
+description         the generic mapping tools
 long_description GMT is an open source collection of ~65 tools  \
     for manipulating geographic and Cartesian data sets and     \
     producing Encapsulated PostScript File (EPS) illustrations  \
     ranging from simple x-y plots via contour maps to           \
     artificially illuminated surfaces and 3-D perspective views.
-conflicts                   gmt
-homepage                    http://www.soest.hawaii.edu/gmt5
-master_sites                ftp://ftp.soest.hawaii.edu/gmt5          \
-                            ftp://ibis.grdl.noaa.gov/pub/gmt5        \
-                            ftp://ftp.iris.washington.edu/pub/gmt5   \
-                            ftp://ftp.iag.usp.br/pub/gmt5            \
-                            ftp://ftp.geologi.uio.no/pub/gmt5        \
-                            ftp://gd.tuwien.ac.at/pub/gmt5           \
-                            ftp://ftp.scc.u-tokai.ac.jp/pub/gmt5     \
-                            ftp://mirror.geosci.usyd.edu.au/pub/gmt5 \
-                            ftp://gmt.mirror.ac.za/pub/gmt5
-use_bzip2                   yes
-set gshhsversion            2.2.0
-set gmtsrc                  gmt-${version}.tar.bz2
-set gshhs                   gshhs-${gshhsversion}.tar.bz2
-distfiles                   ${gmtsrc} ${gshhs}
+conflicts           gmt
+homepage            http://www.soest.hawaii.edu/gmt5
+master_sites        ftp://ftp.soest.hawaii.edu/gmt5          \
+                    ftp://ibis.grdl.noaa.gov/pub/gmt5        \
+                    ftp://ftp.iris.washington.edu/pub/gmt5   \
+                    ftp://ftp.iag.usp.br/pub/gmt5            \
+                    ftp://ftp.geologi.uio.no/pub/gmt5        \
+                    ftp://gd.tuwien.ac.at/pub/gmt5           \
+                    ftp://ftp.scc.u-tokai.ac.jp/pub/gmt5     \
+                    ftp://mirror.geosci.usyd.edu.au/pub/gmt5 \
+                    ftp://gmt.mirror.ac.za/pub/gmt5
+use_bzip2           yes
+set gshhsversion    2.2.0
+set gmtsrc          gmt-${version}.tar.bz2
+set gshhs           gshhs-${gshhsversion}.tar.bz2
+distfiles           ${gmtsrc} ${gshhs}
 checksums           ${gmtsrc} \
                     md5     c5b78de5edab4c42a8a08e7fcfa976b4 \
                     sha1    73b16b25e59fa1cd74bfc01bdeb8170924cbda0c \
@@ -41,10 +41,10 @@
                     sha1    786d58b9a335d3bacb37f40f21ee3bfbb424cd10 \
                     rmd160  aa744b2fdcdf849cc5c4abce97f1d29f4cdc20a4
 
-worksrcdir                  GMT${version}
+worksrcdir          GMT${version}
 
-depends_lib                 port:netcdf \
-                            port:pcre
+depends_lib         port:netcdf \
+                    port:pcre
 post-extract {
     # move GSHHS coastlines to worksrcpath
     system "mv ${workpath}/share/coast ${worksrcpath}/share && rmdir ${workpath}/share"
@@ -88,7 +88,7 @@
     configure.args-append   --enable-triangle
 }
 
-livecheck.type              regex
-livecheck.url               http://www.soest.hawaii.edu/gmt5/gmt/gmt_home.html
-livecheck.regex             {Current version is [^0-9 ]*([0-9]+\.[0-9]+\.[0-9a-z]+)}
+livecheck.type      regex
+livecheck.url       http://www.soest.hawaii.edu/gmt5/gmt/gmt_home.html
+livecheck.regex     {Current version is [^0-9 ]*([0-9]+\.[0-9]+\.[0-9a-z]+)}
 